function [mymu2, myk2, mydist2, mycount2, myKdist2] = eda_kmeans_mod(S, mu)
% k-mean cluster analsis of NxM sample natrix S
% modified per Bradley & Fayyad (1998) never to
% return cluster with zero samples.
% Starts with initial guess KxM mu of cluster means
% returns:
% newmu: new cluster means
% k: Nx1 vector of cluster assignments
% dist: Nx1 vector of distance to cluster center
% count: Kx1 vector of samples in cluster
    [N,M] = size(S);
    initmu = mu;
    [mymu, myk, mydist, mycount, myKdist] = eda_kmeans(S, initmu);
    while min(mycount)==0      % while cluster with no samples
        [t,ic]=min(mycount);   % index of cluster
        [t,ir]=max(mydist);    % index of most distant sample
        ik=myk(ir);            % cluster of this sample
        mymu(ic,1:M) = S(ir,1:M); % new mean
        mycount(ic)=1;         % reset cluster count
        myk(ir)=ic;            % reset sample membership
        mydist(ir)=0.0;        % reset sample distance
        % note: in rare cases, next line could create
        % infinite loop, so don't do it.
        % mycount(ik)=mycount(ik)-1;
    end
    % redo k-means
    [mymu2, myk2, mydist2, mycount2, myKdist2] = eda_kmeans(S, mymu);  
end

