% load the data
K = 3;
D = load('../Data/threeclusters.txt');
[N, M] = size(D);
M = M-1;
S = D(1:N,1:2);
myk = D(1:N,3);
mu = load('../Data/threeclustermeans.txt');

% initial means are means randomly-chosen groups of samples
% bradley-fayyad parameters
Nsets = 100;     % number of small sets
fraction = 0.05; % size of small sets = fraction of N
initmu = eda_bradley_fayyad_mean(S,K,Nsets,fraction);

% k-mean analysis
[mymu, myk, mydist2, mycount, myKdist2] = eda_kmeans(S, initmu);

disp('cluster means');
disp(mymu);
disp('mean sample distance');
disp(mean(sqrt(mydist2)));
disp('cluster counts');
disp(mycount);
disp('mean inter-cluster distance');
disp(mean(sqrt(myKdist2)));

figure(1);
clf;
hold on;
set(gca,'LineWidth',2);
set(gca,'FontSize',14);
axis( [0, 5, 0, 5] );
plot( initmu(1:K,1), initmu(1:K,2), 'r^', 'LineWidth', 2 );
for i=[1:N]
    if myk(i)==1
        plot( S(i,1), S(i,2), 'k.', 'LineWidth', 1 );
    elseif myk(i)==2
        plot( S(i,1), S(i,2), 'k+', 'LineWidth', 1 );
    else
        plot( S(i,1), S(i,2), 'ko', 'LineWidth', 1 );
    end
end
plot( mymu(1:K,1), mymu(1:K,2), 'b^', 'LineWidth', 2 );
xlabel('x');
ylabel('y');